#!/bin/bash
# Software Requirement:
# bash x11-utils awk wmctrl
#
## Custimization
# WMCTRL is the path to wmctrl
WMCTRL="/usr/bin/wmctrl"
# DISTANCE_HORI is the distance to move horizontally
DISTANCE_HORI=20
# DISTANCE_VERT is the distance to move vertically
DISTANCE_VERT=12
# DELAY is the time delay between each pixel movement
# PAUSE is the pause between MOVE_L,MOVE_D,MOVE_R,and MOVE_U
DELAY_HORI=0.02
DELAY_VERT=0.08
PAUSE=0.8

## Functions
#  POS_WINDOWS() determins the position of windows
POS_WINDOWS () {
		#L=(`${WMCTRL} -Gl`);
		#echo '$L'=$L;
		CUR_X=`xwininfo -id $w|awk '$0 ~ /Absolute upper-left X/{ print $4; }'`
		CUR_Y=`xwininfo -id $w|awk '$0 ~ /Absolute upper-left Y/{ print $4; }'`
		#echo '$CUR_Y'=${CUR_Y};
		#echo '$CUR_X'=${CUR_X};
}
#  SHOW_WINDOWS() shows you the windows you can swing
SHOW_WINDOWS () {
	echo "#######################################################"
	${WMCTRL} -l|awk '{ print $1"  "$4" "$5" "$6  }'
	echo "#######################################################"
	select w in `${WMCTRL} -l|awk '{ print $1 }'`
	do W=$w ;
		echo You have selected $w to swing ;
		POS_WINDOWS
		return;
	done
}

# MOVE_R, MOVE_D, MOVE_L, MOVE_U move the window you selected
MOVE_R () {
	for (( x=0 ; x< ${DISTANCE_HORI}; x++ )) ;
		do let CUR_X=${CUR_X}+1;
		#echo '${CUR_X}'=${CUR_X}
		${WMCTRL} -e 0,${CUR_X},${CUR_Y},-1,-1 -i -r $w ;
		POS_WINDOWS
		sleep ${DELAY_HORI};
		done;
}

MOVE_D () {
	for (( y=0 ; y< ${DISTANCE_VERT}; y++ )) ;
		do let CUR_Y=${CUR_Y}+1;
		${WMCTRL} -e 0,${CUR_X},${CUR_Y},-1,-1 -i -r $w ;
		POS_WINDOWS
		sleep ${DELAY_VERT};
		done;
}

MOVE_L () {
	for (( x=0 ; x < ${DISTANCE_HORI}; x++ )) ;
		do let CUR_X=${CUR_X}-1;
		${WMCTRL} -e 0,${CUR_X},${CUR_Y},-1,-1 -i -r $w ;
		POS_WINDOWS
		sleep ${DELAY_HORI};
		done;
}

MOVE_U () {
	for (( y=0 ; y< ${DISTANCE_VERT}; y++ )) ;
		do let CUR_Y=${CUR_Y}-1;
		${WMCTRL} -e 0,${CUR_X},${CUR_Y},-1,-1 -i -r $w ;
		POS_WINDOWS
		sleep ${DELAY_VERT};
		done;
}

SHOW_WINDOWS
while true
	do
# You can change the order of movement as you like
	MOVE_L;
	sleep ${PAUSE}
	MOVE_D;
	sleep ${PAUSE}
	MOVE_R;
	sleep ${PAUSE}
	MOVE_U;
	sleep ${PAUSE}
	done
